Subject: bug#57531: 28.1; Character encoding missing for "eo"

From: Eli Zaretskii <[email-masked]>
Date: Sat, 03 Sep 2022 20:12:58 +0300

> Date: Sat, 03 Sep 2022 16:54:52 +0000
> From: Jonathan Reeve <[email-masked]>
> Cc: [email-masked]
> 
> > The characters in that post are supported by Latin-3, and I had no
> > problem saving them.
> 
> It’s not about saving them, it’s about how they’re displayed.

I believe this is due to the fact that the text was saved in UTF-8,
and Emacs was trying to decode it as if it were in Latin-3.

Using the prefer-coding-system customization should fix that.

> If the rest of my system correctly uses unicode for the `eo' locale, /because it’s a unicode locale,/ but emacs is the only one that guesses it should be Latin-3 instead (for no reason that I can find), then it’s emacs which incorrectly handling this locale.

I disagree.  I think your system doesn't tell Emacs enough to guess
correctly.

> > That’s okay, but then all you need to say in Emacs is
> >
> >   (prefer-coding-system ’utf-8)
> 
> If emacs were really following system settings, it would set the encoding to utf-8 without needing extra customization from the user, since `eo' is a UTF-8 locale.

There's no evidence of "eo" being a UTF-8 locale, except what we see
in glibc.  Which is just one library on just one OS.

> And incidentally, there’s no such locale as `eo.utf-8', from what I can tell.

OK.  I didn't say there were, I just assumed there could be.

> > I don’t know why glibc did that, and glibc-supported systems are not
> > the only ones where we want to support Esperanto.  So if the above
> > simple customization fixes your problem, I’d prefer not changing the
> > default for everyone.
> 
> It’s not about changing the default for everyone, it’s about fixing an incorrect character encoding, making it so that emacs correctly respects the locale’s character set.

Emacs cannot know the system character set unless the system tells
that.  The way to tell that is via the locale's codeset.  If that is
impossible, the next best is for you to tell that to Emacs in your
init file.  I don't understand why you insist on not using the
solution I proposed.

Please try the solution I proposed, and if it doesn't work, let's see
what else is needed.  If you keep insisting on defaulting Esperanto to
UTF-8, I see now way to make any progress here.